<template>
  <div class="container chat">
    <h2
      class="center teal-text"
    >
      Chat room
    </h2>
    <div class="card">
      <div class="card-content">
        <ul class="messages">
          <li
            :key="message.id"
            v-for="message in messages"
          >
            <h5 class="teal-text">{{message.name}}</h5>
            <p class="grey-text text-darken-3">{{message.content}}</p>
            <p class="grey-text time">{{message.timestamp}}</p>
          </li>
        </ul>
      </div>
      <div class="card-action">
        <new-message :name="name"/>
      </div>
    </div>
  </div>
</template>

<script>
import NewMessage from '@/components/NewMessage'
import db from '@/firebase/init'
import moment from 'moment'

export default {
  name: "Chat",
  props: {
    name: String
  },
  components: {
    NewMessage
  },
  data () {
    return {
      messages: []
    }
  },
  created() {
    let dbRef = db.collection('messages').orderBy('timestamp')

    dbRef.onSnapshot( (snapshot) => {
      snapshot.docChanges().forEach( (change) => {
        if(change.type == 'added') {
          let doc = change.doc
          this.messages.push({
            id: doc.id,
            name: doc.data().name,
            content: doc.data().content,
            timestamp: moment(doc.data().timestamp).format('lll')
          })
        }
      })
    })
  }
}

</script>

<style>
.chat h2 {
  font-size: 2.6rem;
  margin-bottom: 40px;
}
.chat span {
  font-size: 1.4em;
}
.chat .time {
  display: block;
  font-size: 1.2em;
}
.messages li {
  margin-bottom: 30px;
}
</style>